<?php

#Проверки на файл с сайтами
if(!file_exists("sites.dat"))
	file_put_contents("sites.dat", "");

if(!is_readable("sites.dat")) 
	die("<title>Ошибка</title><meta charset=\"utf-8\">Файл sites.dat недоступен для чтения. Проверьте права доступа к файлу и папке со скриптом.");

if(!is_writable("sites.dat")) 
	die("<title>Ошибка</title><meta charset=\"utf-8\">Файл sites.dat недоступен для записи. Проверьте права доступа к файлу и папке со скриптом.");

#Сброс данных
if(isset($_GET['do']) && $_GET['do']=="flush") {
	file_put_contents("sites.dat", "");
}

#Удаление сайта
if(isset($_GET['do']) && $_GET['do']=="delete") {
	$domain = $_GET['domain'];

	$data = file_get_contents("sites.dat");
	$sites = unserialize($data);

	$sites = array_diff($sites, array($domain));

	file_put_contents("sites.dat", serialize($sites));
	die();
}

#Добавление сайтов
if(isset($_POST['sites'])){
	$data=explode("\n", trim($_POST['sites']));

	$sites = array();

	foreach ($data as $v) {
		$site=trim($v);

		list($domain,$pass) = explode(":", $site);
		$domain = strtolower($domain);
		if(strlen($pass)>0) {
			$cookie = auth_li($domain,$pass);
			$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv",$cookie);
		} else {
			$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv");
		}

		$data = trim($data);

		#Проверяем, доступна ли статистика
		if($data == '"статистика сайта";"обновлено {date} в {time}"') {
			echo "<br>Статистика сайта <strong>$site</strong> недоступна - его нет в LI, или нужен пароль, или пароль неправильный";
		} else {
			$sites[]=$domain.":$pass";
		}

	}


	$data = file_get_contents("sites.dat");
	$exist_sites = unserialize($data);

	#Объединяем с текущими и удаляем дубли
	if($exist_sites) {
		$merge = array_merge($exist_sites,$sites);
		$merge = array_unique($merge);
	} else $merge=$sites;

	file_put_contents("sites.dat", serialize($merge));
}

if(isset($_GET['period']))
	$period=$_GET['period'];
else
	$period="";
?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Статистика LI</title>

    <style>
    	body { font-family: Helvetica;  background-color: #eee;}
    	table.sites {border-collapse: collapse; border: 1px gray solid; color: #333; width: 100%; margin-top: 20px;}
    	table.sites td, table.sites th {padding: 5px;border: 1px gray solid;}
    	table.sites thead {background-color: #ddd;}
    	table.sites th {font-size: 10pt;}
    	table.sites tbody tr:hover {background-color: #eee;}
    	.container {background-color: #fff; padding: 20px; padding-top: 10px; padding-bottom: 10px; margin: 0 auto; max-width: 700px; box-shadow: 0 0 5px gray;}
    	a {color: black; }
    	a:hover {color: red;}
    	ul.nav {margin: 0; padding: 0; list-style-type: none; text-align: center; font-size: 10pt; float: right;}
    	ul.nav li { display: inline;}
    	.nav a { color: #444;}
    	.nav a:hover {color: black;}
    	hr {color: #ccc;}
    	a.jslink {cursor: pointer; text-decoration: none; border-bottom: 1px black dashed;}
    	a.jslink:hover {color: red; border-bottom: 1px red dashed;}
    	li.selected {font-weight: bold;}
    </style>
  </head>

  <body>

<div class="container">

	<span style="font-family: Georgia;">Статистика посещаемости</span>

	<ul class="nav">
		<li <?=($period=="") ? "class=selected":"";?>><a href="?">По дням</a> |
		<li <?=($period=="week") ? "class=selected":"";?>><a href="?period=week">По неделям</a> |
		<li <?=($period=="month") ? "class=selected":"";?>><a href="?period=month">По месяцам</a>
	</ul>

	<hr noshade>

	<div style="clear: both;"></div>
<?php

$data = file_get_contents("sites.dat");
$sites = unserialize($data);

if(!$sites) {
	echo "<h2>Вы еще не добавили ни одного сайта</h2><p>Добавить (каждый сайт с новой строчки, если есть пароль - то site.ru:password):
	<form method=post>
		<textarea name='sites' rows=10 cols=50></textarea>
		<p><input type='submit' value='Добавить сайты'>
	</form>";
	die();
}

#Определяем сайт с самой долгой статистикой, чтобы отсеять новые сайты
foreach ($sites as $site) {
	list($domain,$pass) = explode(":", $site);
	$csv[$domain]=get_stats($site);
	$li[$domain]=li_stat($domain);
}


foreach($sites as $site) {

	list($domain,$pass) = explode(":", $site);
	$max_days = 0; 
	if(count($csv[$domain]) > $max_days) $full_site=$domain;
}

for($i=0; $i<=30; $i++) {
	$stat[$i]['views']=0;
	$stat[$i]['visitors']=0; 

	$stat[$i]['date']=$csv[$full_site][$i]['date'];

	foreach ($sites as $site) {
		list($domain,$pass) = explode(":", $site);
		$stat[$i]['views']+=$csv[$domain][$i]['views'];
		$stat[$i]['visitors']+=$csv[$domain][$i]['visitors'];
	}
}

?>


<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script type="text/javascript">
 
// Load the Visualization API library and the piechart library.
google.load('visualization', '1.0', {'packages':['corechart']});
google.setOnLoadCallback(drawChart);
   // ... draw the chart...
 
function drawChart() {
 
    // Create the data table.
    var data = new google.visualization.DataTable();
        data.addColumn('date', 'Дата');
    data.addColumn('number', 'Посетителей');
    data.addColumn('number', 'Просмотров');
    data.addRows([
    <?php
    foreach($stat as $v) {
		$date=$v['date']*1000;
		if($date>0)	echo "[new Date($date), {$v['visitors']}, {$v['views']}],\n";
    }
    ?>
]);
        var options = {
        colors: ['blue','green'],
        'width':700,
        'height':200,
        'legend':{'position':'none'},
        'titleTextStyle':{'fontName':'Georgia','fontSize':18,'bold':false},
        <? if($period==""):?>hAxis: {format: 'd MMMM'},<?endif;?>
        chartArea: {width: '100%', height: '90%', top: 0},
        series: {0 :  {areaOpacity:0.15}},
        vAxis: {textPosition: 'in',minValue: 0},          
    };
 
    // Instantiate and draw our chart, passing in some options.
    var chart = new google.visualization.AreaChart(document.getElementById('chart_div'));
    chart.draw(data, options);
}
</script>
 

<div id="chart_div" style="width: 700px; height: 200px;"></div>



<table class="sites">
<thead>
	<tr>
		<th rowspan=2>Сайт
		<th colspan=2>
			<?
			if($period=="week") echo "Прошлая неделя";
			elseif($period=="month") echo "Прошлый месяц";
			else echo "Вчера";
			?>
		<th colspan=2>Сегодня
		<th rowspan=2>&nbsp;
	<tr>
		<th>Посетителей
		<th>Просмотров
		<th>Посетителей
		<th>Просмотров



</thead>

<tbody>
<?php
$day_vis=0; $day_hit=0; $today_vis=0; $today_hit=0; $visitors=0; $views=0;
foreach ($sites as $site) {
	list($domain,$pass) = explode(":", $site);
	$max=count($csv[$domain])-1;
	$pre=count($csv[$domain])-2;
	echo "<tr id=\"tr_$site\"><td><a href=\"http://$domain/\" target=_blank>$domain</a> <small style=\"float: right;\"><a href=\"http://www.liveinternet.ru/stat/$domain/\" target=_blank>LI</a></small>
	<td>".number_format($csv[$domain][$max]['visitors'])." ".diff($csv[$domain][$max]['visitors'],$csv[$domain][$pre]['visitors'])."
	<td>".number_format($csv[$domain][$max]['views'])." ".diff($csv[$domain][$max]['views'],$csv[$domain][$pre]['views'])."
	<td>".number_format($li[$domain]['today_vis'])."
	<td>".number_format($li[$domain]['today_hit'])."
	<td><a style=\"cursor: pointer; color: red;\" title=\"Удалить сайт\" onclick=\"del('$site');\">&times;</a>";

	$day_vis+=$csv[$domain][$max]['visitors'];
	$day_hit+=$csv[$domain][$max]['views'];
	$today_vis+=$li[$domain]['today_vis'];
	$today_hit+=$li[$domain]['today_hit'];
	$visitors+=$csv[$domain][$pre]['visitors'];
	$views+=$csv[$domain][$pre]['views'];

}

echo "<tr><td><strong>Всего:</strong>
<td><strong>".number_format($day_vis)." ".diff($day_vis,$visitors)."</strong>
<td><strong>".number_format($day_hit)." ".diff($day_hit,$views)."</strong>
<td><strong>".number_format($today_vis)."</strong>
<td><strong>".number_format($today_hit)."</strong>
<td><a style=\"color: red;\" href=\"?do=flush\" onclick=\"return confirm('Вы уверены, что хотите удалить все сайты?')\" title=\"Удалить все сайты\">&sum;</a>
";
?>
</tbody>
</table>


<p><a onclick="toggle(add_sites)" class="jslink">Добавить сайты &darr;</a>
	<div id="add_sites" style="display: none;">
		<p style="color: gray;">Каждый сайт с новой строчки, если есть пароль - то site.ru:password
		<form method=post>
			<textarea name='sites' rows=10 cols=50></textarea>
			<p><input type='submit' value='Добавить сайты'>
		</form>
	</div>


<p style="color: gray; font-size: 10pt; float: right;">Li Charts v0.3, &copy; <a href="http://spryt.ru/">Spryt</a>, 2015

<script type="text/javascript">
function getXmlHttp(){
  var xmlhttp;
  try {
    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (E) {
      xmlhttp = false;
    }
  }
  if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
    xmlhttp = new XMLHttpRequest();
  }
  return xmlhttp;
}


function del(domain){

	if(confirm('Вы уверены, что хотите удалить сайт "' + domain +'"?')){

		var req = getXmlHttp()  

		req.onreadystatechange = function() {  
			if (req.readyState == 4) { 
				if(req.status == 200) { 
					document.getElementById("tr_"+domain).style.display = "none";
				}
			}
		}

		req.open('GET', '?do=delete&domain=' + domain, true);  
		req.send(null);
		//document.getElementById("manage_"+id).innerHTML = '<img src="http://'+document.domain+'/bootstrap/load2.gif">';
	}	
}

function toggle(el) {
  el.style.display = (el.style.display == 'none') ? '' : 'none'
}
</script>
</body>
</html>

<?php

#Получение статистики из csv
function get_stats($site) {
	global $period;

	if($period!="") $liperiod=";period=".$period; else $liperiod="";

	list($domain,$pass) = explode(":", $site);
	if(strlen($pass)>0) {
		$cookie = auth_li($domain,$pass);
		$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv$liperiod",$cookie);
	} else {
		$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv$liperiod");
	}

	$strings = explode("\n", $data);
	unset($strings[0]);

	$max=count($strings);
	unset($strings[$max]);

	$i=0;
	foreach ($strings as $key => $value) {
		
		list($date,$views,$visitors)=explode(";", $value);
		
		if($period=="month") {
			$date="1 ".str_replace("\"", "", $date);
			$date=mb_strtolower($date,'UTF-8');
			$date=str_replace(" 1", " 201", $date);
		} 

		if($period=="week") {
			$date=str_replace("\"", "", $date);

			list($day,$mon) = explode(" ", $date);

			$mon = str_replace(
				array("янв","фев","мар","апр","май","июн","июл","авг","сен","окт","ноя","дек"),
				array('1','2','3','4','5','6','7 ','8','9','10','11','12'),
			$mon);

			//Выставляем правильный год
			if($mon > date("n") ) $year=date("Y")-1; else $year=date("Y");

			$date.=" $year";
		}

		if ($period==""){
			$date=str_replace("\"", "", $date)." ".date("Y");
		}

		$date = str_replace(
			array("янв","фев","мар","апр","май","июн","июл","авг","сен","окт","ноя","дек"),
			array('January','February','March','April','May','June','July ','August','September','October','November','December'),
			$date);


		$csv[$i]['date']=strtotime($date);
		$csv[$i]['views']=floor($views);
		$csv[$i]['visitors']=floor($visitors);
		$i++;
	}

	return $csv;
}

#Авторизация и получение куки в LI
function auth_li($domain,$pass) {

	$c = curl_init("http://www.li.ru/stat/");
	curl_setopt($c, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($c, CURLOPT_POST, TRUE);
	curl_setopt($c, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0");
	curl_setopt($c, CURLOPT_POSTFIELDS, "url=$domain&password=$pass");
	curl_setopt($c, CURLOPT_HEADER, TRUE);
	curl_setopt($c, CURLOPT_FOLLOWLOCATION, true);
	$data = curl_exec($c);
	if($data === false) echo "\nCurl error: ".curl_error($c);
	
	$header=substr($data,0,curl_getinfo($c,CURLINFO_HEADER_SIZE));
	curl_close($c);

	preg_match_all("/Set-Cookie: (.*?)=(.*?);/i",$header,$res);
	$cookie='';
	foreach ($res[1] as $key => $value) $cookie.= $value.'='.$res[2][$key].'; ';

	if(strlen($cookie)==0) $cookie=FALSE;

	return $cookie;
}

function get_data($url,$cookie="") {

	$c = curl_init($url);
	curl_setopt($c, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($c, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0");
	curl_setopt($c, CURLOPT_TIMEOUT, 30);
	curl_setopt($c, CURLOPT_COOKIE, $cookie);
	curl_setopt($c, CURLOPT_HEADER, FALSE);
	//curl_setopt($c, CURLOPT_FOLLOWLOCATION, TRUE);
	$data = curl_exec($c);
	if($data === false) echo "\nCurl error: ".curl_error($c);
	curl_close($c);

	return $data;
}

function li_stat($url){
	$url=str_replace("www.","",$url);
	
	$lines = file("http://counter.yadro.ru/values?site=".$url);
	$info = array();
	foreach($lines as $line){
		if(preg_match("|LI_([^ ]+) = (\d*);|",$line,$ok)){
			$info[$ok[1]] = $ok[2];
		}
	}

	return $info;
}

function diff($start,$end) {
	$diff = $start - $end;
	$plus="";
	if($diff>0) {
		$color = "green"; 
		$plus= "+";
	}
	else 
		$color = "red";

	if($diff!=0) 
		return "<span style='color: $color; font-size: 10pt;'>$plus".number_format($diff)."</span>";
} 

?>